
/*   f6x86.c Part of f6x86, an xforms based program for viewing/setting
             some of the registers within the Cyrix/IBM 6x86 CPU.

	Copyright (C) 1996 Ian J Peters  (ijp@floot.demon.co.uk)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "forms.h"
#include <stdlib.h>
#include "f6x86.h"

FD_f6x86 *create_form_f6x86(void)
{
	char s[100];
	int i;
  FL_OBJECT *obj;
  FD_f6x86 *fdui = (FD_f6x86 *) fl_calloc(1, sizeof(*fdui));

  fdui->f6x86 = fl_bgn_form(FL_NO_BOX, 450, 450);
  obj = fl_add_box(FL_UP_BOX,0,0,450,450,"");

	obj = fl_add_text(FL_NORMAL_TEXT,25,10,400,20
		,"No detection yet, 6x86 processor assumed");
	fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
	fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
	fl_set_object_lstyle(obj,FL_BOLD_STYLE);
/* DEVID STUFF */
  obj =fl_add_text(FL_NORMAL_TEXT,30,40,50,30,"devID");
  fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
  fl_set_object_lstyle(obj,FL_NORMAL_STYLE /* +FL_ENGRAVED_STYLE */ );
  fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
  fdui->devidtext=obj = fl_add_text(FL_NORMAL_TEXT,80,40,50,30,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_INACTIVE,FL_MCOL);
    fl_set_object_lcol(obj,FL_WHITE);
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);

  obj =fl_add_text(FL_NORMAL_TEXT,142,40,50,30,"step");
  fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
  fl_set_object_lstyle(obj,FL_NORMAL_STYLE /* +FL_ENGRAVED_STYLE */ );
  fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
  fdui->devsteptext=obj = fl_add_text(FL_NORMAL_TEXT,190,40,50,30,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_INACTIVE,FL_MCOL);
    fl_set_object_lcol(obj,FL_WHITE);
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);

  obj =fl_add_text(FL_NORMAL_TEXT,260,40,50,30,"rev");
  fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
  fl_set_object_lstyle(obj,FL_NORMAL_STYLE /* +FL_ENGRAVED_STYLE */ );
  fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
  fdui->devrevtext=obj = fl_add_text(FL_NORMAL_TEXT,300,40,50,30,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_INACTIVE,FL_MCOL);
    fl_set_object_lcol(obj,FL_WHITE);
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);

	fdui->devidqbutton = obj = fl_add_button(FL_NORMAL_BUTTON,390,40,30,30,"?");
	fl_set_object_lsize(obj,FL_LARGE_SIZE);
	fl_set_object_lstyle(obj,FL_NORMAL_STYLE+FL_ENGRAVED_STYLE);
	fl_set_object_callback(obj,devid_qbutton,0);

/*  MAPEN stuff */
  fdui->mapentext = obj = fl_add_text(FL_NORMAL_TEXT,270,80,40,30,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_INACTIVE,FL_MCOL);
    fl_set_object_lcol(obj,FL_WHITE);
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);

  obj =fl_add_text(FL_NORMAL_TEXT,70,82,180,30,"All registers enabled");
    fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE /* +FL_ENGRAVED_STYLE */ );
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
  fdui->mapenbutton = obj = fl_add_roundbutton(FL_PUSH_BUTTON,30,80,40,30,"");
    fl_set_object_color(obj,FL_RED,FL_GREEN);
/*    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_lstyle(obj,FL_NORMAL_STYLE+FL_ENGRAVED_STYLE);
*/
    fl_set_object_callback(obj,mapen_button,0);

	fdui->mapenqbutton = obj = fl_add_button(FL_NORMAL_BUTTON,390,80,30,30,"?");
	fl_set_object_lsize(obj,FL_LARGE_SIZE);
	fl_set_object_lstyle(obj,FL_NORMAL_STYLE+FL_ENGRAVED_STYLE);
	fl_set_object_callback(obj,mapen_qbutton,0);


/*  HLT stuff */
  fdui->hlttext = obj = fl_add_text(FL_NORMAL_TEXT,270,120,40,30,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_INACTIVE,FL_MCOL);
    fl_set_object_lcol(obj,FL_WHITE);
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);

  obj =fl_add_text(FL_NORMAL_TEXT,70,122,180,30,"HLT power saving mode");
    fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE /* +FL_ENGRAVED_STYLE */ );
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
  fdui->hltbutton = obj = fl_add_roundbutton(FL_PUSH_BUTTON,30,120,40,30,"");
    fl_set_object_color(obj,FL_RED,FL_GREEN);
/*    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_lstyle(obj,FL_NORMAL_STYLE+FL_ENGRAVED_STYLE);
*/
    fl_set_object_callback(obj,hlt_button,0);

	fdui->hltqbutton = obj = fl_add_button(FL_NORMAL_BUTTON,390,120,30,30,"?");
	fl_set_object_lsize(obj,FL_LARGE_SIZE);
	fl_set_object_lstyle(obj,FL_NORMAL_STYLE+FL_ENGRAVED_STYLE);
	fl_set_object_callback(obj,hlt_qbutton,0);


/*  IO recovery timing stuff */
  fdui->iorectext = obj = fl_add_text(FL_NORMAL_TEXT,270,160,80,30,"unknown");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_INACTIVE,FL_MCOL);
    fl_set_object_lcol(obj,FL_WHITE);
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);

  obj =fl_add_text(FL_NORMAL_TEXT,70,162,180,30,"IO recovery time (IORT)");
    fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE /* +FL_ENGRAVED_STYLE */ );
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);

	fdui->iorecqbutton = obj = fl_add_button(FL_NORMAL_BUTTON,390,160,30,30,"?");
	fl_set_object_lsize(obj,FL_LARGE_SIZE);
	fl_set_object_lstyle(obj,FL_NORMAL_STYLE+FL_ENGRAVED_STYLE);
	fl_set_object_callback(obj,iorec_qbutton,0);


/*  LINBRST stuff */
  fdui->linbrsttext = obj = fl_add_text(FL_NORMAL_TEXT,270,200,70,30,"unknown");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_INACTIVE,FL_MCOL);
    fl_set_object_lcol(obj,FL_WHITE);
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);

  obj =fl_add_text(FL_NORMAL_TEXT,65,202,190,30,"Burst address sequence");
    fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE /* +FL_ENGRAVED_STYLE */ );
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    
    fdui->linbrstbutton = obj = fl_add_roundbutton(FL_PUSH_BUTTON,30,200,40,30,"");
    fl_set_object_color(obj,FL_RED,FL_GREEN);
/*    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_lstyle(obj,FL_NORMAL_STYLE+FL_ENGRAVED_STYLE);
*/
    fl_set_object_callback(obj,linbrst_button,0);

	fdui->linbrstqbutton = obj = fl_add_button(FL_NORMAL_BUTTON,390,200,30,30,"?");
	fl_set_object_lsize(obj,FL_LARGE_SIZE);
	fl_set_object_lstyle(obj,FL_NORMAL_STYLE+FL_ENGRAVED_STYLE);
	fl_set_object_callback(obj,linbrst_qbutton,0);


/*  WT_ALLOC stuff */
  fdui->wtalloctext = obj = fl_add_text(FL_NORMAL_TEXT,270,240,95,30,"unknown");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_INACTIVE,FL_MCOL);
    fl_set_object_lcol(obj,FL_WHITE);
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);

  obj =fl_add_text(FL_NORMAL_TEXT,65,242,190,30,"Cache allocation policy");
    fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE /* +FL_ENGRAVED_STYLE */ );
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);

  fdui->wtallocbutton = obj = fl_add_roundbutton(FL_PUSH_BUTTON,30,240,40,30,"");
    fl_set_object_color(obj,FL_RED,FL_GREEN);
/*    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_lstyle(obj,FL_NORMAL_STYLE+FL_ENGRAVED_STYLE);
*/
    fl_set_object_callback(obj,wtalloc_button,0);

	fdui->wtallocqbutton = obj = fl_add_button(FL_NORMAL_BUTTON,390,240,30,30,"?");
	fl_set_object_lsize(obj,FL_LARGE_SIZE);
	fl_set_object_lstyle(obj,FL_NORMAL_STYLE+FL_ENGRAVED_STYLE);
	fl_set_object_callback(obj,wtalloc_qbutton,0);


/*  NC1 stuff */
  fdui->nc1text = obj = fl_add_text(FL_NORMAL_TEXT,270,280,40,30,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_INACTIVE,FL_MCOL);
    fl_set_object_lcol(obj,FL_WHITE);
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);

  obj =fl_add_text(FL_NORMAL_TEXT,70,282,180,30,"640K to 1M cacheable");
    fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE /* +FL_ENGRAVED_STYLE */ );
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
  fdui->nc1button = obj = fl_add_roundbutton(FL_PUSH_BUTTON,30,280,40,30,"");
    fl_set_object_color(obj,FL_RED,FL_GREEN);
/*    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_lstyle(obj,FL_NORMAL_STYLE+FL_ENGRAVED_STYLE);
*/
    fl_set_object_callback(obj,nc1_button,0);

	fdui->nc1qbutton = obj = fl_add_button(FL_NORMAL_BUTTON,390,280,30,30,"?");
	fl_set_object_lsize(obj,FL_LARGE_SIZE);
	fl_set_object_lstyle(obj,FL_NORMAL_STYLE+FL_ENGRAVED_STYLE);
	fl_set_object_callback(obj,nc1_qbutton,0);


/*  DTE_EN stuff */
  fdui->dteentext = obj = fl_add_text(FL_NORMAL_TEXT,270,320,75,30,"unknown");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_INACTIVE,FL_MCOL);
    fl_set_object_lcol(obj,FL_WHITE);
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);

  obj =fl_add_text(FL_NORMAL_TEXT,65,322,190,30,"DTE cache");
    fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE /* +FL_ENGRAVED_STYLE */ );
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);

  fdui->dteenbutton = obj = fl_add_roundbutton(FL_PUSH_BUTTON,30,320,40,30,"");
    fl_set_object_color(obj,FL_RED,FL_GREEN);
/*    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_lstyle(obj,FL_NORMAL_STYLE+FL_ENGRAVED_STYLE);
*/
    fl_set_object_callback(obj,dteen_button,0);

	fdui->dteenqbutton = obj = fl_add_button(FL_NORMAL_BUTTON,390,320,30,30,"?");
	fl_set_object_lsize(obj,FL_LARGE_SIZE);
	fl_set_object_lstyle(obj,FL_NORMAL_STYLE+FL_ENGRAVED_STYLE);
	fl_set_object_callback(obj,dteen_qbutton,0);


/* arr button */
  fdui->arrbutton = obj = fl_add_button(FL_NORMAL_BUTTON,70,360,200,35,"Address Region Registers");
    fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE+FL_ENGRAVED_STYLE);
    fl_set_object_callback(obj,arr_button,0);
    
/* QUIT BUTTONS */
  fdui->quitbutton = obj = fl_add_button(FL_NORMAL_BUTTON,20,405,160,35,"Quit without saving");
    fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE+FL_ENGRAVED_STYLE);
  fdui->savebutton = obj = fl_add_button(FL_NORMAL_BUTTON,193,405,170,35,"Save to 6x86 and quit");
    fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE+FL_ENGRAVED_STYLE);
/* ABOUT button */
	fdui->aboutbutton = obj = fl_add_button(FL_NORMAL_BUTTON,376,405,58,35,"About");
	fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
	fl_set_object_lstyle(obj,FL_BOLD_STYLE+FL_ENGRAVED_STYLE);
	fl_set_object_callback(obj,about_button,0);

  fl_end_form();

	return(fdui);
}

void get_reg_values(void)
{
	char s[100];
	int i;
/* devid */
	i=get_reg(DIR0_REG,-1);
	sprintf(s,"0x%x",i);
	fl_set_object_label(fd_f6x86->devidtext,s);
	i=get_reg(DIR1_REG,-1);
	sprintf(s,"0x%x",i/16);
	fl_set_object_label(fd_f6x86->devsteptext,s);
	sprintf(s,"0x%x",i&0xf);
	fl_set_object_label(fd_f6x86->devrevtext,s);
/* mapen */
	fl_set_button(fd_f6x86->mapenbutton,1);
	mapen_flag=get_reg(MAPEN_REG,MAPEN_BIT);
	if (mapen_flag==0)
	{
		fl_set_object_label(fd_f6x86->mapentext,"No");
		fl_set_object_color(fd_f6x86->mapenbutton,FL_COL1,FL_RED);
	}
	else
	{
		fl_set_object_label(fd_f6x86->mapentext,"Yes");
		fl_set_object_color(fd_f6x86->mapenbutton,FL_COL1,FL_GREEN);
	}

/* hlt */
	fl_set_button(fd_f6x86->hltbutton,1);
	if (hlt_init_flag==0)
	{
		hlt_flag=get_reg(HLT_REG,HLT_BIT);
		hlt_init_flag=1;
	}
	if (hlt_flag==0)
	{
		fl_set_object_label(fd_f6x86->hlttext,"Off");
		fl_set_object_color(fd_f6x86->hltbutton,FL_COL1,FL_RED);
	}
	else
	{
		fl_set_object_label(fd_f6x86->hlttext,"On");
		fl_set_object_color(fd_f6x86->hltbutton,FL_COL1,FL_GREEN);
	}
/* io recovery */
	if (mapen_flag!=0)
	{
		i=get_reg(IORT_REG,-1);
		switch (i&0x7)
		{
			case (0): strcpy(s,"1 clock"); break;
			case (1): strcpy(s,"2 clocks"); break;
			case (2): strcpy(s,"4 clocks"); break;
			case (3): strcpy(s,"8 clocks"); break;
			case (4): strcpy(s,"16 clocks"); break;
			case (5): strcpy(s,"32 clocks"); break;
			case (6): strcpy(s,"64 clocks"); break;
			case (7): strcpy(s,"No delay"); break;
		}
	}
	else
		strcpy(s,"unknown");
	fl_set_object_label(fd_f6x86->iorectext,s);

/* wt_alloc */
	fl_set_button(fd_f6x86->wtallocbutton,1);
	if (mapen_flag!=0)
	{
		if (wtalloc_init_flag==0)
		{
			wtalloc_flag=get_reg(WT_ALLOC_REG,WT_ALLOC_BIT);
			wtalloc_init_flag=1;
		}
		if (wtalloc_flag==0)
		{
			fl_set_object_label(fd_f6x86->wtalloctext,"read miss");
			fl_set_object_color(fd_f6x86->wtallocbutton,FL_COL1,FL_RED);
		}
		else
		{
			fl_set_object_label(fd_f6x86->wtalloctext,"read/write miss");
			fl_set_object_color(fd_f6x86->wtallocbutton,FL_COL1,FL_GREEN);
		}
	}
	else
	{
		fl_set_object_label(fd_f6x86->wtalloctext,"unknown");
		fl_set_object_color(fd_f6x86->wtallocbutton,FL_DARKGOLD,FL_DARKGOLD);
	}

/* linbrst */

	fl_set_button(fd_f6x86->linbrstbutton,1);
	if (linbrst_init_flag==0)
	{
		linbrst_flag=get_reg(LINBRST_REG,LINBRST_BIT);
		linbrst_init_flag=1;
	}
	if (linbrst_flag==0)
	{
		fl_set_object_label(fd_f6x86->linbrsttext," 1 + 4");
		fl_set_object_color(fd_f6x86->linbrstbutton,FL_COL1,FL_RED);
	}
	else
	{
		fl_set_object_label(fd_f6x86->linbrsttext,"Linear");
		fl_set_object_color(fd_f6x86->linbrstbutton,FL_COL1,FL_GREEN);
	}

/* nc1 */
	fl_set_button(fd_f6x86->nc1button,1);
	if (nc1_init_flag==0)
	{
		nc1_flag=get_reg(NC1_REG,NC1_BIT);
		nc1_init_flag=1;
	}
	if (nc1_flag==0)
	{
		fl_set_object_label(fd_f6x86->nc1text,"Yes");
		fl_set_object_color(fd_f6x86->nc1button,FL_COL1,FL_RED);
	}
	else
	{
		fl_set_object_label(fd_f6x86->nc1text,"No");
		fl_set_object_color(fd_f6x86->nc1button,FL_COL1,FL_GREEN);
	}

/* dteen */
	fl_set_button(fd_f6x86->dteenbutton,1);
	if (mapen_flag!=0)
	{
		if (dteen_init_flag==0)
		{
			dteen_flag=get_reg(DTE_EN_REG,DTE_EN_BIT);
			dteen_init_flag=1;
		}
		if (dteen_flag==0)
		{
			fl_set_object_label(fd_f6x86->dteentext,"Disabled");
			fl_set_object_color(fd_f6x86->dteenbutton,FL_COL1,FL_RED);
		}
		else
		{
			fl_set_object_label(fd_f6x86->dteentext,"Enabled");
			fl_set_object_color(fd_f6x86->dteenbutton,FL_COL1,FL_GREEN);
		}
	}
	else
	{
		fl_set_object_label(fd_f6x86->dteentext,"unknown");
		fl_set_object_color(fd_f6x86->dteenbutton,FL_DARKGOLD,FL_DARKGOLD);
	}

}


int get_reg(int reg,int bit)
{
	int i,r,v;
	char com[128],s[256],*sp;
	FILE *inf;
	sprintf(com,"get6x86 0x%x",reg);
	if ((inf=popen(com,"r"))==0)
	{
		fl_show_alert("I can't execute get6x86"
			,"It must be on your path and suid root."
			," ",0);
		exit(1);
	}
	i=-1;
	do
	{
		s[++i]=fgetc(inf);
	} while (feof(inf)==0 && i<250);
	sp=strstr(s,"0x");
	if (sp==0)
	{
		fl_show_alert("The command",com,"failed.",0);
		exit(1);
	}
	sscanf(sp,"0x%x",&r);
	if (r!=reg)
	{
		fl_show_alert("The command",com
			,"produced a bad result",0);
		printf("%s\n",s);
		exit(1);
	}
	sp=strstr(sp+2,"0x");
	if (sp==0)
	{
		fl_show_alert("The command",com,"Reg ok, value failed",0);
		exit(1);
	}
	sscanf(sp,"0x%x",&v);
	last_reg_val=v;
	if (bit<0)
		return(v);
	if ((v&bit)!=0)
		return(1);
	return(0);
}


void set_reg(int reg,int bit)
{
	char s[100];
	if (get_reg(reg,bit)!=0)
		return;
	last_reg_val|=bit;
	sprintf(s,"set6x86 -s 0x%x 0x%x",reg,last_reg_val);
	system(s);
	if (get_reg(reg,bit)==0)
		fl_show_alert("Failed",s,"Failed to set the desired bit",0);
}


void reset_reg(int reg,int bit)
{
        char s[100];
                if (get_reg(reg,bit)==0)
                                return;
	last_reg_val&=(0xff-bit);
	sprintf(s,"set6x86 -s 0x%x 0x%x",reg,last_reg_val);
	system(s);
	if (get_reg(reg,bit)!=0)
		fl_show_alert("Failed",s,"Failed to reset the desired bit",0);
}


/*  ADDRESS REGION REGISTERS */

FD_arr *create_form_arr(void)
{
	char s[100];
	int i;
  FL_OBJECT *obj;
  FD_arr *fdui = (FD_arr *) fl_calloc(1, sizeof(*fdui));

  fdui->arr = fl_bgn_form(FL_NO_BOX, 560, 470);
  obj = fl_add_box(FL_UP_BOX,0,0,560,470,"");

/* TITLE */
	obj = fl_add_text(FL_NORMAL_TEXT,50,10,460,30,"Address Region Registers");
	fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
	fl_set_object_lsize(obj,FL_LARGE_SIZE);
	fl_set_object_lstyle(obj,FL_BOLD_STYLE);
/* mapen WARNING 
	fdui->arrmapentext = obj = fl_add_text(FL_NORMAL_TEXT,50,45,460,30,"");
	fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
	fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
	fl_set_object_lstyle(obj,FL_BOLD_STYLE);
*/
	
/* DISMISS BUTTON */
	fdui->dismissbutton = obj = fl_add_button(FL_NORMAL_BUTTON,230,430,100,35,"Dismiss");
	fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
	fl_set_object_lstyle(obj,FL_NORMAL_STYLE+FL_EMBOSSED_STYLE);

/* start text */
	obj =fl_add_text(FL_NORMAL_TEXT,95,80,70,30,"Start");
	fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
	fl_set_object_lstyle(obj,FL_BOLD_STYLE /* +FL_ENGRAVED_STYLE */ );
	fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
/* size text */
	obj =fl_add_text(FL_NORMAL_TEXT,195,80,70,30,"Size");
	fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
	fl_set_object_lstyle(obj,FL_BOLD_STYLE /* +FL_ENGRAVED_STYLE */ );
	fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
/* control register bit values text */
	obj =fl_add_text(FL_NORMAL_TEXT,290,75,40,30,"NLB");
	fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
	fl_set_object_lstyle(obj,FL_BOLD_STYLE /* +FL_ENGRAVED_STYLE */ );
	fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
	obj =fl_add_text(FL_NORMAL_TEXT,330,75,40,30,"WT");
	fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
	fl_set_object_lstyle(obj,FL_BOLD_STYLE /* +FL_ENGRAVED_STYLE */ );
	fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
	obj =fl_add_text(FL_NORMAL_TEXT,370,75,40,30,"WG");
	fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
	fl_set_object_lstyle(obj,FL_BOLD_STYLE /* +FL_ENGRAVED_STYLE */ );
	fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
	obj =fl_add_text(FL_NORMAL_TEXT,410,75,40,30,"WL");
	fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
	fl_set_object_lstyle(obj,FL_BOLD_STYLE /* +FL_ENGRAVED_STYLE */ );
	fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
	obj =fl_add_text(FL_NORMAL_TEXT,450,75,46,30,"WWO");
	fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
	fl_set_object_lstyle(obj,FL_BOLD_STYLE /* +FL_ENGRAVED_STYLE */ );
	fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
	obj =fl_add_text(FL_NORMAL_TEXT,500,75,40,30,"RCE");
	fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
	fl_set_object_lstyle(obj,FL_BOLD_STYLE /* +FL_ENGRAVED_STYLE */ );
	fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);

/* control register help buttons */
	fdui->arrnlbqbutton = obj = fl_add_button(FL_NORMAL_BUTTON,298,141,30,30,"?");
	fl_set_object_lsize(obj,FL_LARGE_SIZE);
	fl_set_object_lstyle(obj,FL_NORMAL_STYLE+FL_ENGRAVED_STYLE);
	fl_set_object_callback(obj,arrnlb_qbutton,0);
	fdui->arrwtqbutton = obj = fl_add_button(FL_NORMAL_BUTTON,338,141,30,30,"?");
	fl_set_object_lsize(obj,FL_LARGE_SIZE);
	fl_set_object_lstyle(obj,FL_NORMAL_STYLE+FL_ENGRAVED_STYLE);
	fl_set_object_callback(obj,arrwt_qbutton,0);
	fdui->arrwgqbutton = obj = fl_add_button(FL_NORMAL_BUTTON,378,141,30,30,"?");
	fl_set_object_lsize(obj,FL_LARGE_SIZE);
	fl_set_object_lstyle(obj,FL_NORMAL_STYLE+FL_ENGRAVED_STYLE);
	fl_set_object_callback(obj,arrwg_qbutton,0);
	fdui->arrwlqbutton = obj = fl_add_button(FL_NORMAL_BUTTON,418,141,30,30,"?");
	fl_set_object_lsize(obj,FL_LARGE_SIZE);
	fl_set_object_lstyle(obj,FL_NORMAL_STYLE+FL_ENGRAVED_STYLE);
	fl_set_object_callback(obj,arrwl_qbutton,0);
	fdui->arrwwoqbutton = obj = fl_add_button(FL_NORMAL_BUTTON,458,141,30,30,"?");
	fl_set_object_lsize(obj,FL_LARGE_SIZE);
	fl_set_object_lstyle(obj,FL_NORMAL_STYLE+FL_ENGRAVED_STYLE);
	fl_set_object_callback(obj,arrwwo_qbutton,0);
	fdui->arrrceqbutton = obj = fl_add_button(FL_NORMAL_BUTTON,498,141,30,30,"?");
	fl_set_object_lsize(obj,FL_LARGE_SIZE);
	fl_set_object_lstyle(obj,FL_NORMAL_STYLE+FL_ENGRAVED_STYLE);
	fl_set_object_callback(obj,arrrce_qbutton,0);

/* arr7 help button */
	fdui->arrarr7qbutton = obj = fl_add_button(FL_NORMAL_BUTTON,36,80,30,30,"?");
	fl_set_object_lsize(obj,FL_LARGE_SIZE);
	fl_set_object_lstyle(obj,FL_NORMAL_STYLE+FL_ENGRAVED_STYLE);
	fl_set_object_callback(obj,arrarr7_qbutton,0);


/* 1st 7 arr regs */
	for (i=0;i<7;i++)
	{
		fdui->arrstarttext[i] = obj = fl_add_text(FL_NORMAL_TEXT,90,170+i*35,90,30,"unknown");
		fl_set_object_boxtype(obj,FL_DOWN_BOX);
		fl_set_object_color(obj,FL_INACTIVE,FL_MCOL);
		fl_set_object_lcol(obj,FL_WHITE);
		fl_set_object_lsize(obj,FL_NORMAL_SIZE);
		fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);

		fdui->arrsizetext[i] = obj = fl_add_text(FL_NORMAL_TEXT,200,170+i*35,70,30,"unknown");
		fl_set_object_boxtype(obj,FL_DOWN_BOX);
		fl_set_object_color(obj,FL_INACTIVE,FL_MCOL);
		fl_set_object_lcol(obj,FL_WHITE);
		fl_set_object_lsize(obj,FL_NORMAL_SIZE);
		fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);

		sprintf(s,"ARR%d",i);
		obj =fl_add_text(FL_NORMAL_TEXT,15,170+i*35,70,30,s);
		fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
		fl_set_object_lstyle(obj,FL_BOLD_STYLE /* +FL_ENGRAVED_STYLE */ );
		fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);

		fdui->arrnlbbutton[i] = obj 
			= fl_add_roundbutton(FL_PUSH_BUTTON,300,170+i*35,30,30,"");
		fl_set_object_callback(obj,arrnlb_button,i);
		fdui->arrwtbutton[i] = obj 
			= fl_add_roundbutton(FL_PUSH_BUTTON,340,170+i*35,30,30,"");
		fl_set_object_callback(obj,arrwt_button,i);
		fdui->arrwgbutton[i] = obj 
			= fl_add_roundbutton(FL_PUSH_BUTTON,380,170+i*35,30,30,"");
		fl_set_object_callback(obj,arrwg_button,i);
		fdui->arrwlbutton[i] = obj 
			= fl_add_roundbutton(FL_PUSH_BUTTON,420,170+i*35,30,30,"");
		fl_set_object_callback(obj,arrwl_button,i);
		fdui->arrwwobutton[i] = obj 
			= fl_add_roundbutton(FL_PUSH_BUTTON,460,170+i*35,30,30,"");
		fl_set_object_callback(obj,arrwwo_button,i);
		fdui->arrrcdbutton[i] = obj 
			= fl_add_roundbutton(FL_PUSH_BUTTON,500,170+i*35,30,30,"");
		fl_set_object_callback(obj,arrrcd_button,i);


	}
	fdui->arrstarttext[7] = obj = fl_add_text(FL_NORMAL_TEXT,90,110,90,30,"unknown");
	fl_set_object_boxtype(obj,FL_DOWN_BOX);
	fl_set_object_color(obj,FL_INACTIVE,FL_MCOL);
	fl_set_object_lcol(obj,FL_WHITE);
	fl_set_object_lsize(obj,FL_NORMAL_SIZE);
	fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);

	fdui->arrsizetext[7] = obj = fl_add_text(FL_NORMAL_TEXT,200,110,70,30,"unknown");
	fl_set_object_boxtype(obj,FL_DOWN_BOX);
	fl_set_object_color(obj,FL_INACTIVE,FL_MCOL);
	fl_set_object_lcol(obj,FL_WHITE);
	fl_set_object_lsize(obj,FL_NORMAL_SIZE);
	fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);

	obj =fl_add_text(FL_NORMAL_TEXT,15,110,70,30,"ARR7");
	fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
	fl_set_object_lstyle(obj,FL_BOLD_STYLE /* +FL_ENGRAVED_STYLE */ );
	fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);

	fdui->arrnlbbutton[7] = obj 
		= fl_add_roundbutton(FL_PUSH_BUTTON,300,110,30,30,"");
	fl_set_object_callback(obj,arrnlb_button,7);
	fdui->arrwtbutton[7] = obj 
		= fl_add_roundbutton(FL_PUSH_BUTTON,340,110,30,30,"");
	fl_set_object_callback(obj,arrwt_button,7);
	fdui->arrwgbutton[7] = obj 
		= fl_add_roundbutton(FL_PUSH_BUTTON,380,110,30,30,"");
	fl_set_object_callback(obj,arrwg_button,7);
	fdui->arrwlbutton[7] = obj 
		= fl_add_roundbutton(FL_PUSH_BUTTON,420,110,30,30,"");
	fl_set_object_callback(obj,arrwl_button,7);
	fdui->arrwwobutton[7] = obj 
		= fl_add_roundbutton(FL_PUSH_BUTTON,460,110,30,30,"");
	fl_set_object_callback(obj,arrwwo_button,7);
	fdui->arrrcdbutton[7] = obj 
		= fl_add_roundbutton(FL_PUSH_BUTTON,500,110,30,30,"");
	fl_set_object_callback(obj,arrrcd_button,7);

	
   fl_end_form();
   return(fdui);
}


void get_arr_reg_values(void)
{
	char s[256];
	int i,j,r1,r2,r3,addr,size;
	if (mapen_flag==0)
	{
		j=4;
		for (i=4;i<8;i++)
		{
			fl_set_object_label(fd_arr->arrstarttext[i],"Unknown");
			fl_set_object_label(fd_arr->arrsizetext[i],"Unknown");
		}
	}
	else
		j=8;
	for (i=0;i<j;i++)
	{
		r1=get_reg(arr_reg[i],-1);
		r2=get_reg(arr_reg[i]+1,-1);
		r3=get_reg(arr_reg[i]+2,-1);
		addr=r1<<24+r2<<16+((r3&0xf0)<<8);
		size=r3&0xf;
		if (addr%(1024*1024)==0)
			sprintf(s,"%d M",addr/(1024*1024));
		else
			sprintf(s,"%d K",addr/1024);
		fl_set_object_label(fd_arr->arrstarttext[i],s);
		if (i<7)
			strcpy(s,arr_size[size]);
		else
			strcpy(s,arr_size7[size]);
		fl_set_object_label(fd_arr->arrsizetext[i],s);
	}
	for (i=0;i<8;i++)
	{
		fl_set_button(fd_arr->arrnlbbutton[i],1);
		fl_set_button(fd_arr->arrwtbutton[i],1);
		fl_set_button(fd_arr->arrwgbutton[i],1);
		fl_set_button(fd_arr->arrwlbutton[i],1);
		fl_set_button(fd_arr->arrwwobutton[i],1);
		fl_set_button(fd_arr->arrrcdbutton[i],1);
		if (mapen_flag!=0)
		{
			r1=get_reg(RCR_REG+i,-1);
			if (((r1&1)==0 && i!=7) || ((r1&1)!=0 && i==7))
				fl_set_object_color(fd_arr->arrrcdbutton[i],FL_COL1,FL_GREEN);
			else if (((r1&1)==0 && i==7) || ((r1&1)!=0 && i!=7))
				fl_set_object_color(fd_arr->arrrcdbutton[i],FL_COL1,FL_RED);
			if ((r1&2)==0)
				fl_set_object_color(fd_arr->arrwwobutton[i],FL_COL1,FL_RED);
			else
				fl_set_object_color(fd_arr->arrwwobutton[i],FL_COL1,FL_GREEN);
			if ((r1&4)==0)
				fl_set_object_color(fd_arr->arrwlbutton[i],FL_COL1,FL_RED);
			else
				fl_set_object_color(fd_arr->arrwlbutton[i],FL_COL1,FL_GREEN);
			if ((r1&8)==0)
				fl_set_object_color(fd_arr->arrwgbutton[i],FL_COL1,FL_RED);
			else
				fl_set_object_color(fd_arr->arrwgbutton[i],FL_COL1,FL_GREEN);
			if ((r1&16)==0)
				fl_set_object_color(fd_arr->arrwtbutton[i],FL_COL1,FL_RED);
			else
				fl_set_object_color(fd_arr->arrwtbutton[i],FL_COL1,FL_GREEN);
			if ((r1&32)==0)
				fl_set_object_color(fd_arr->arrnlbbutton[i],FL_COL1,FL_RED);
			else
				fl_set_object_color(fd_arr->arrnlbbutton[i],FL_COL1,FL_GREEN);
		}
		else
		{
			fl_set_object_color(fd_arr->arrnlbbutton[i],FL_DARKGOLD,FL_DARKGOLD);
			fl_set_object_color(fd_arr->arrwtbutton[i],FL_DARKGOLD,FL_DARKGOLD);
			fl_set_object_color(fd_arr->arrwgbutton[i],FL_DARKGOLD,FL_DARKGOLD);
			fl_set_object_color(fd_arr->arrwlbutton[i],FL_DARKGOLD,FL_DARKGOLD);
			fl_set_object_color(fd_arr->arrwwobutton[i],FL_DARKGOLD,FL_DARKGOLD);
			fl_set_object_color(fd_arr->arrrcdbutton[i],FL_DARKGOLD,FL_DARKGOLD);
		}
	
	}
}


