/*   f6x86.h Part of f6x86, an xforms based program for viewing/setting
             some of the registers within the Cyrix/IBM 6x86 CPU.

	Copyright (C) 1996 Ian J Peters  (ijp@floot.demon.co.uk)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef FD_f6x86_h_
#define FD_f6x86_h_

extern void hlt_button(FL_OBJECT *, long);
extern void linbrst_button(FL_OBJECT *, long);
extern void mapen_button(FL_OBJECT *, long);
extern void wtalloc_button(FL_OBJECT *, long);
extern void nc1_button(FL_OBJECT *, long);
extern void dteen_button(FL_OBJECT *, long);
extern void about_button(FL_OBJECT *, long);
extern void devid_qbutton(FL_OBJECT *, long);
extern void mapen_qbutton(FL_OBJECT *, long);
extern void hlt_qbutton(FL_OBJECT *, long);
extern void iorec_qbutton(FL_OBJECT *, long);
extern void linbrst_qbutton(FL_OBJECT *, long);
extern void wtalloc_qbutton(FL_OBJECT *, long);
extern void nc1_qbutton(FL_OBJECT *, long);
extern void dteen_qbutton(FL_OBJECT *, long);
extern void arr_button(FL_OBJECT *, long);
extern void arrnlb_button(FL_OBJECT *, long);
extern void arrwt_button(FL_OBJECT *, long);
extern void arrwg_button(FL_OBJECT *, long);
extern void arrwl_button(FL_OBJECT *, long);
extern void arrwwo_button(FL_OBJECT *, long);
extern void arrrcd_button(FL_OBJECT *, long);
extern void arrnlb_qbutton(FL_OBJECT *, long);
extern void arrwt_qbutton(FL_OBJECT *, long);
extern void arrwg_qbutton(FL_OBJECT *, long);
extern void arrwl_qbutton(FL_OBJECT *, long);
extern void arrwwo_qbutton(FL_OBJECT *, long);
extern void arrrce_qbutton(FL_OBJECT *, long);
extern void arrarr7_qbutton(FL_OBJECT *, long);
extern void get_arr_reg_values(void);

/**** Forms and Objects ****/

typedef struct {
	FL_FORM *f6x86;
	FL_OBJECT *devidtext;
	FL_OBJECT *devsteptext;
	FL_OBJECT *devrevtext;
	FL_OBJECT *mapentext;
	FL_OBJECT *mapenbutton;
	FL_OBJECT *hlttext;
	FL_OBJECT *iorectext;
	FL_OBJECT *hltbutton;
	FL_OBJECT *linbrsttext;
	FL_OBJECT *linbrstbutton;
	FL_OBJECT *wtalloctext;
	FL_OBJECT *wtallocbutton;
	FL_OBJECT *nc1text;
	FL_OBJECT *nc1button;
	FL_OBJECT *dteentext;
	FL_OBJECT *dteenbutton;
	FL_OBJECT *arrbutton;
	FL_OBJECT *quitbutton;
	FL_OBJECT *savebutton;
	FL_OBJECT *aboutbutton;
	FL_OBJECT *devidqbutton;
	FL_OBJECT *mapenqbutton;
	FL_OBJECT *hltqbutton;
	FL_OBJECT *iorecqbutton;
	FL_OBJECT *linbrstqbutton;
	FL_OBJECT *wtallocqbutton;
	FL_OBJECT *nc1qbutton;
	FL_OBJECT *dteenqbutton;
	void *vdata;
	long ldata;
} FD_f6x86;

typedef struct {
	FL_FORM *arr;
/*	FL_OBJECT *arrmapentext;
*/
	FL_OBJECT *arrstarttext[8];
	FL_OBJECT *arrsizetext[8];
	FL_OBJECT *arrnlbbutton[8];
	FL_OBJECT *arrnlbqbutton;
	FL_OBJECT *arrwtbutton[8];
	FL_OBJECT *arrwtqbutton;
	FL_OBJECT *arrwgbutton[8];
	FL_OBJECT *arrwgqbutton;
	FL_OBJECT *arrwlbutton[8];
	FL_OBJECT *arrwlqbutton;
	FL_OBJECT *arrwwobutton[8];
	FL_OBJECT *arrwwoqbutton;
	FL_OBJECT *arrrcdbutton[8];
	FL_OBJECT *arrrceqbutton;
	FL_OBJECT *arrarr7qbutton;
	FL_OBJECT *dismissbutton;
	void *vdata;
	long ldata;
} FD_arr;

extern FD_f6x86 * create_form_f6x86(void);
extern FD_arr * create_form_arr(void);

extern char arr_size[][20],arr_size7[][20];
extern int last_reg_val,mapen_flag,save_flag,quit_flag;
extern int hlt_flag,hlt_init_flag,linbrst_flag,linbrst_init_flag;
extern int wtalloc_flag,wtalloc_init_flag,nc1_flag,nc1_init_flag;
extern int dteen_flag,dteen_init_flag;
extern int arr_reg[];
extern FD_f6x86 *fd_f6x86;
extern FD_arr *fd_arr;

extern int get_reg(int,int);
extern void set_reg(int,int);
extern void reset_reg(int,int);
extern void get_reg_values(void);

#define MAPEN_REG 0xc3
#define MAPEN_BIT 0x10
#define HLT_REG 0xc2
#define HLT_BIT 0x08
#define DIR0_REG 0xfe
#define DIR1_REG 0xff
#define IORT_REG 0xe8
#define LINBRST_REG 0xc3
#define LINBRST_BIT 0x4
#define WT_ALLOC_REG 0xe9
#define WT_ALLOC_BIT 0x1
#define NC1_REG 0xc0
#define NC1_BIT 0x2
#define DTE_EN_REG 0xe8
#define DTE_EN_BIT 0x10
#define RCR_REG 0xdc

#endif /* FD_f6x86_h_ */
