/*   f6x86.c Part of f6x86, an xforms based program for viewing/setting
             some of the registers within the Cyrix/IBM 6x86 CPU.

	Copyright (C) 1996 Ian J Peters  (ijp@floot.demon.co.uk)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "forms.h"
#include "f6x86.h"

/* callbacks for form f6x86 */

void hlt_button(FL_OBJECT *ob, long data)
{
	fl_set_button(ob,1);
	if (hlt_flag!=0)
	{
		fl_set_object_label(fd_f6x86->hlttext,"Off");
		fl_set_object_color(fd_f6x86->hltbutton,FL_COL1,FL_RED);
		hlt_flag=0;
	}
	else
	{
		fl_set_object_label(fd_f6x86->hlttext,"On");
		fl_set_object_color(fd_f6x86->hltbutton,FL_COL1,FL_GREEN);
		hlt_flag=1;
	}
}

void linbrst_button(FL_OBJECT *ob, long data)
{
	fl_set_button(ob,1);
	if (linbrst_flag!=0)
	{
		fl_set_object_label(fd_f6x86->linbrsttext," 1 + 4");
		fl_set_object_color(fd_f6x86->linbrstbutton,FL_COL1,FL_RED);
		linbrst_flag=0;
	}
	else
	{
		fl_set_object_label(fd_f6x86->linbrsttext,"Linear");
		fl_set_object_color(fd_f6x86->linbrstbutton,FL_COL1,FL_GREEN);
		linbrst_flag=1;
	}
}

void mapen_button(FL_OBJECT *ob, long data)
{
	fl_set_button(ob,1);
	if (mapen_flag!=0)
	{
		reset_reg(MAPEN_REG,MAPEN_BIT);
	}
	else
	{
		set_reg(MAPEN_REG,MAPEN_BIT);
	}
	get_reg_values();
}

void wtalloc_button(FL_OBJECT *ob, long data)
{
	fl_set_button(ob,1);
	if (mapen_flag==0)
	{
		fl_show_alert("Register not accessible"
			,"You must enable all registers"
			,"to toggle this setting",0);
		return;
	}
	if (wtalloc_flag!=0)
	{
		fl_set_object_label(fd_f6x86->wtalloctext,"read miss");
		fl_set_object_color(fd_f6x86->wtallocbutton,FL_COL1,FL_RED);
		wtalloc_flag=0;
	}
	else
	{
		fl_set_object_label(fd_f6x86->wtalloctext,"read/write miss");
		fl_set_object_color(fd_f6x86->wtallocbutton,FL_COL1,FL_GREEN);
		wtalloc_flag=1;
	}
}

void nc1_button(FL_OBJECT *ob, long data)
{
	fl_set_button(ob,1);
	if (nc1_flag!=0)
	{
		fl_set_object_label(fd_f6x86->nc1text,"Yes");
		fl_set_object_color(fd_f6x86->nc1button,FL_COL1,FL_RED);
		nc1_flag=0;
	}
	else
	{
		fl_set_object_label(fd_f6x86->nc1text,"No");
		fl_set_object_color(fd_f6x86->nc1button,FL_COL1,FL_GREEN);
		nc1_flag=1;
	}
}

void dteen_button(FL_OBJECT *ob, long data)
{
	fl_set_button(ob,1);
	if (mapen_flag==0)
	{
		fl_show_alert("Register not accessible"
			,"You must enable all registers"
			,"to toggle this setting",0);
		return;
	}
	if (dteen_flag!=0)
	{
		fl_set_object_label(fd_f6x86->dteentext,"Disabled");
		fl_set_object_color(fd_f6x86->dteenbutton,FL_COL1,FL_RED);
		dteen_flag=0;
	}	
	else
	{
		fl_set_object_label(fd_f6x86->dteentext,"Enabled");
		fl_set_object_color(fd_f6x86->dteenbutton,FL_COL1,FL_GREEN);
		dteen_flag=1;
	}
}

void arr_button(FL_OBJECT *ob, long data)
{
	FL_OBJECT *but;
	if (mapen_flag==0)
	{
		if (fl_show_question("All registers not enabled"
			,"You must enable them to get useful information."
			,"Do you want to look at the ARR page anyway?")==0)
		return;
	}
	fl_show_form(fd_arr->arr,FL_PLACE_CENTER,FL_FULLBORDER,"arr");
	get_arr_reg_values();
	do
	{
		but=fl_do_forms();
		if (but==fd_f6x86->savebutton)
			save_flag=1;
		if (but==fd_f6x86->quitbutton)
			quit_flag=1;
	} while (but!=fd_arr->dismissbutton && quit_flag==0 && save_flag==0);
	fl_hide_form(fd_arr->arr);
}

void about_button(FL_OBJECT *ob, long data)
{
	fl_show_alert("f6x86 (c) I J Peters 1996 GNU GPL"
		,"I can be contacted at ijp@floot.demon.co.uk if you have"
		,"problems, or want me to add more info.",0);
}

void devid_qbutton(FL_OBJECT *ob, long data)
{
	fl_show_alert("Device Identification"
		,"This shows the 6x86 device ID along with the"
		,"stepping and revision number (0x31,0x1,0x4 for me).",0);
}

void mapen_qbutton(FL_OBJECT *ob, long data)
{
	fl_show_alert("MAP Enable"
		,"When green/on, all configuration registers are enabled."
		,"This becomes active at once, unlike the other buttons.",0);
}

void hlt_qbutton(FL_OBJECT *ob, long data)
{
	fl_show_alert("HLT power saving mode"
		,"When green/on, the CPU enters low power mode when the HLT"
		,"instruction is executed. This can reduce heating problems.",0);
}

void iorec_qbutton(FL_OBJECT *ob, long data)
{
	fl_show_alert("I/O Recovery time"
		,"This is the minimum number of bus clocks between I/O"
		,"accesses. Use your BIOS setup or set6x86 to alter this.",0);
}

void linbrst_qbutton(FL_OBJECT *ob, long data)
{
	fl_show_alert("Linear Burst Address sequence"
		,"This will show 'Linear' or '1 + 4'. Linear is faster."
		,"This could be 'risky' to change; let your BIOS do it.",0);
}

void wtalloc_qbutton(FL_OBJECT *ob, long data)
{
	fl_show_alert("Write Through Allocate"
		,"Read miss: cache lines allocated for read misses only."
		,"R/W miss: CLA for R/W misses. This one could be interesting.",0);
}

void nc1_qbutton(FL_OBJECT *ob, long data)
{
	fl_show_alert("Cache 640K to 1M"
		,"Address region 640K to 1M is cacheable or not."
		,"It's probably a bad idea to change this.",0);
}
void dteen_qbutton(FL_OBJECT *ob, long data)
{
	fl_show_alert("Directory Table Entry cache"
		,"This is memory management stuff within the 6x86 (nothing"
		,"to do with disks). It will usually be enabled.",0);
}



/* ******** ARR calbacks ********* */

void arrnlb_button(FL_OBJECT *ob, long data)
{
	fl_set_button(ob,1);
}

void arrwt_button(FL_OBJECT *ob, long data)
{
	fl_set_button(ob,1);
}

void arrwg_button(FL_OBJECT *ob, long data)
{
	fl_set_button(ob,1);
}

void arrwl_button(FL_OBJECT *ob, long data)
{
	fl_set_button(ob,1);
}

void arrwwo_button(FL_OBJECT *ob, long data)
{
	fl_set_button(ob,1);
}

void arrrcd_button(FL_OBJECT *ob, long data)
{
	fl_set_button(ob,1);
}

/* ARR help buttons */ 
void arrnlb_qbutton(FL_OBJECT *ob, long data)
{
	fl_show_alert("No Local Bus","If green, the LBA# pin is not asserted"
		,"for that address region",0);
}

void arrwt_qbutton(FL_OBJECT *ob, long data)
{
	fl_show_alert("Write Through","If green, address region is write through"
		,"(as opposed to write back).",0);
}

void arrwg_qbutton(FL_OBJECT *ob, long data)
{
	fl_show_alert("Write Gathering","If green, write gathering is enabled"
		,"for that address region",0);
}

void arrwl_qbutton(FL_OBJECT *ob, long data)
{
	fl_show_alert("Weak Locking","If green, weak locking is enabled for that"
		,"address region",0);
}

void arrwwo_qbutton(FL_OBJECT *ob, long data)
{
	fl_show_alert("Weak Write Ordering","If green, weak write ordering is"
		,"enabled for that address region",0);
}

void arrrce_qbutton(FL_OBJECT *ob, long data)
{
	fl_show_alert("Region Cache Enable","If green, the CPU cache is enabled"
		,"for that address region",0);
}

void arrarr7_qbutton(FL_OBJECT *ob, long data)
{
	fl_show_alert("ARR7 describes the main memory"
		," If it says 'unknown', you will have to 'enable all registers'"
		,"(the first item in the first window)",0);
}

