/*   f6x86.c Part of f6x86, an xforms based program for viewing/setting
             some of the registers within the Cyrix/IBM 6x86 CPU.

	Copyright (C) 1996 Ian J Peters  (ijp@floot.demon.co.uk)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "forms.h"
#include "f6x86.h"

int last_reg_val,mapen_flag,init_mapen_value,hlt_flag,hlt_init_flag=0;
int linbrst_flag,linbrst_init_flag=0,wtalloc_flag,wtalloc_init_flag=0;
int nc1_flag,nc1_init_flag=0,dteen_flag,dteen_init_flag=0;
int save_flag=0,quit_flag=0;
int arr_reg[]={0xc4,0xc7,0xca,0xcd,0xd0,0xd3,0xd6,0xd9};
char arr_size[][20]={" Disabled"," 4 K"," 8 K"," 16 K"," 32K"," 64K"," 128K"
		," 256K"," 512K"," 1M"," 2M"," 4M"," 8M"," 16M"
		," 32M"," 4G"};
char arr_size7[][20]={" Disabled"," 256K"," 512K"," 1M"," 2M"," 4M"," 8M"
		," 16M"," 32M"," 64M"," 128M"," 256M"," 512M"
		," 1G"," 2G"," 4G"};

FD_f6x86 *fd_f6x86;
FD_arr   *fd_arr;

int main(int argc, char *argv[])
{
	int exit_flag=0;
	FL_OBJECT *but;

	fl_initialize(&argc, argv, 0, 0, 0);
	fd_f6x86 = create_form_f6x86();
	fd_arr = create_form_arr();
	
	get_reg_values();
	init_mapen_value=get_reg(MAPEN_REG,MAPEN_BIT);
	fl_show_form(fd_f6x86->f6x86,FL_PLACE_CENTER,FL_FULLBORDER
		,"f6x86 (c) I J Peters GNU GPL");
	fl_set_goodies_font(FL_NORMAL_STYLE,FL_MEDIUM_SIZE);
	do
	{
		but=fl_do_forms();
		if (save_flag)
			but=fd_f6x86->savebutton;
		if (quit_flag)
			but=fd_f6x86->quitbutton;
		if (but==fd_f6x86->savebutton)
		{
			if (fl_show_question("Are you sure?"
				,"You do this at your own risk"
				,"Your computer might hang")==0)
				continue;
			exit_flag=1;
	/* mapen */	if (mapen_flag==0)
				reset_reg(MAPEN_REG,MAPEN_BIT);
			else
				set_reg(MAPEN_REG,MAPEN_BIT);
	/* hlt */	if (hlt_flag==0)
				reset_reg(HLT_REG,HLT_BIT);
			else
				set_reg(HLT_REG,HLT_BIT);
	/* linbrst */	if (linbrst_flag==0)
				reset_reg(LINBRST_REG,LINBRST_BIT);
			else
				set_reg(LINBRST_REG,LINBRST_BIT);
	/* wtalloc */	if (mapen_flag!=0)
			{
				if (wtalloc_flag==0)
					reset_reg(WT_ALLOC_REG,WT_ALLOC_BIT);
				else
					set_reg(WT_ALLOC_REG,WT_ALLOC_BIT);
			}
	/* nc1 */	if (nc1_flag==0)
				reset_reg(NC1_REG,NC1_BIT);
			else
				set_reg(NC1_REG,NC1_BIT);
	/* dteen */	if (mapen_flag!=0)
			{
				if (dteen_flag==0)
					reset_reg(DTE_EN_REG,DTE_EN_BIT);
				else
					set_reg(DTE_EN_REG,DTE_EN_BIT);
			}

		}
		else if (but==fd_f6x86->quitbutton)
		{
			exit_flag=1;
			if (init_mapen_value==0)
				reset_reg(MAPEN_REG,MAPEN_BIT);
			else
				set_reg(MAPEN_REG,MAPEN_BIT);
		}
	} while (exit_flag==0);
   return 0;
}

